/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web;

/**
 * A DAOException is thrown whenever an application tries to access a persistent
 * representation but the data storage is unavailable or unable to retrieve the
 * datas.
 * 
 * @author rlogiacco@smartlab.net
 */
public class DAOException extends Exception {

	private static final long serialVersionUID = 5044473395562877556L;

	/**
	 * Default empty constructor.
	 */
	public DAOException() {
		super();
	}

	/**
	 * Constructs a new instance with the specified describing message.
	 * 
	 * @param message the description of the occurred exception.
	 */
	public DAOException(String message) {
		super(message);
	}

	/**
	 * Constructs a new instance with the specified cause.
	 * 
	 * @param cause the <code>throwable</code> instance wich generated this
	 *            exception.
	 */
	public DAOException(Throwable cause) {
		super(cause);
	}

	/**
	 * Constructs a new instance with the specified describing message and
	 * cause.
	 * 
	 * @param message the description of the occurred exception.
	 * @param cause the <code>throwable</code> instance wich generated this
	 *            exception.
	 */
	public DAOException(String message, Throwable cause) {
		super(message, cause);
	}
}