/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.bean;

import java.util.Locale;

/**
 * @TODO documentation
 * 
 * @author rlogiacco@smartlab.net
 */
public class BooleanConverter extends Converter {

	private boolean value;

	/**
	 * @TODO documentation
	 * 
	 * @param value
	 */
	public BooleanConverter(boolean value) {
		this.value = value;
	}

	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class type, Object value, Locale locale) throws ConversionException {
		if (type.equals(Boolean.class) || type.equals(Boolean.TYPE)) {
			if (value.toString().equalsIgnoreCase("on") || value.toString().equalsIgnoreCase("y") || value.toString().equalsIgnoreCase("yes")
					|| value.toString().equalsIgnoreCase("1") || value.toString().equalsIgnoreCase("true")) {
				return Boolean.TRUE;
			} else if (value.toString().equalsIgnoreCase("off") || value.toString().equalsIgnoreCase("n") || value.toString().equalsIgnoreCase("no")
					|| value.toString().equalsIgnoreCase("0") || value.toString().equalsIgnoreCase("false")) {
				return Boolean.FALSE;
			} else {
				throw new ConversionException("Unable to convert to boolean `" + value + "`");
			}
		} else {
			return value.toString();
		}
	}
    
    /**
     * @TODO documentation
     * 
     * @return
     */
    protected boolean hasDefault() {
        return true;
    }

    /**
     * @TODO documentation
     * 
     * @return
     */
    protected boolean getDefault() {
        return value;
    }
}