/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.bean;

import java.text.DateFormat;
import java.text.ParseException;
import java.util.Locale;

/**
 * @TODO documentation
 * 
 * @author rlogiacco@smartlab.net
 */
public class DateConverter extends Converter {

	/**
	 * @TODO documentation
	 */
	protected int format;

	/**
	 * @TODO documentation
	 */
	public DateConverter() {
		this(DateFormat.SHORT);
	}

	/**
	 * @TODO documentation
	 * 
	 * @param format
	 */
	public DateConverter(int format) {
		this.format = format;
	}

	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class type, Object value, Locale locale) throws ConversionException {
		try {
			if (value.toString().trim().length() > 0) {
				if (type.equals(java.sql.Date.class)) {
					return new java.sql.Date(DateFormat.getDateInstance(format, locale).parse(value.toString()).getTime());
				} else if (type.equals(java.util.Date.class)) {
					return DateFormat.getDateInstance(format, locale).parse(value.toString());
				} else {
					return DateFormat.getDateInstance(format, locale).format(((java.util.Date)value));
				}
			} else {
				return null;
			}
		} catch (ParseException pe) {
			throw new ConversionException("Invalid date " + value.toString(), pe);
		}
	}
}