/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.page;

import java.io.Writer;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;

import net.smartlab.web.EmptyMarkerTag;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.taglib.TagUtils;
import org.apache.struts.taglib.html.Constants;

/**
 * @TODO documentation
 * 
 * @author rlogiacco@smartlab.net
 * @jsp.tag name = "reminder" body-content = "empty"
 */
public class ReminderTag extends AbstractTag {

	/**
	 * @TODO documentation Comment for <code>property</code>
	 */
	private String property;

	/**
	 * @TODO documentation Comment for <code>value</code>
	 */
	private String value;

	/**
	 * @param value the value to set.
	 * @jsp.attribute required="true" rtexprvalue="true"
	 */
	public void setValue(String value) {
		this.value = value;
	}

	/**
	 * @param property the property to set.
	 * @jsp.attribute required="true" rtexprvalue="true"
	 */
	public void setProperty(String property) {
		this.property = property;
	}

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException {
		String[] items = null;
		try {
			String[] values = (String[])TagUtils.getInstance().lookup(super.context, Constants.BEAN_KEY, property, null);
			items = new String[values.length];
			System.arraycopy(values, 0, items, 0, items.length);
		} catch (Exception e) {
			items = context.getRequest().getParameterValues(property);
		}
		if (items != null) {
			try {
				Paginator paginator = super.getPaginator();
				paginator.reset();
				while (paginator.hasNext()) {
					Object item = BeanUtils.getProperty(paginator.next(), value);
					for (int i = 0; i < items.length; i++) {
						if (item != null && items[i] != null && (items[i].equals(EmptyMarkerTag.EMPTY_MARKER) || items[i].equals(item.toString()))) {
							items[i] = null;
							break;
						}
					}
				}
				paginator.reset();
				Writer out = context.getOut();
				for (int i = 0; i < items.length; i++) {
					if (items[i] != null) {
						out.write("<input type=\"hidden\" name=\"" + property + "\" value=\"" + items[i] + "\"/>");
					}
				}
			} catch (Exception e) {
				throw new JspTagException(e);
			}
		}
		return EVAL_PAGE;
	}
}